package com.fp.frontend.controller.armas.solicitud;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.ViewScoped;

import org.apache.commons.httpclient.methods.GetMethod;

import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.query.DtoQuery;
import com.fp.dto.query.Filter;
import com.fp.dto.query.SubQuery;
import com.fp.dto.save.DtoSave;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.controller.pentaho.PentahoController;
import com.fp.frontend.controller.pgeneral.gene.ParametersController;
import com.fp.frontend.helper.MessageHelper;
import com.fp.persistence.parmas.soli.TarmSolicitudTramite;
import com.fp.persistence.pgeneral.gene.TgeneCatalog;
import com.fp.persistence.pgeneral.gene.TgeneParameters;

@SuppressWarnings("serial")
@ManagedBean
@ViewScoped
public class SolicitudTramiteController extends AbstractController<TarmSolicitudTramite> {

    /**
     * Constructor
     *
     * @throws Exception
     */
    public SolicitudTramiteController() throws Exception {
        super(TarmSolicitudTramite.class);
    }

    /**
     * Metodo invocado despues de instanciar el controlador
     */
    @PostConstruct
    private void postconstruct() {
        this.init();
        // Inicializa autoconsulta
        super.startQuery();
    }

    /**
     * Incializa variables del controlador, cuando se esta utilizando una pagina
     * que utliza el controlador.
     */
    private void init() {
        try {
            this.recperpage = 10; // Cambiar al # reg a mirar.
            this.lrecord = new ArrayList<>();
            this.beanalias = "SOLICITUDTRAM";
        } catch (Exception e) {
            MessageHelper.setMessageError(e);
        }
    }

    /* (non-Javadoc)
	 * @see com.fp.frontend.controller.AbstractController#querydatabase()
     */
    @SuppressWarnings("unchecked")
    @Override
    protected void querydatabase() {
        try {
            Request request = this.callerhelper.getRequest();
            DtoQuery dto = super.getDtoQuery(true);

            SubQuery subqueryestadosolicitud = new SubQuery("TarmSolicitud", "estado", "estadoSolicitud", "i.pk=t.pk.csolicitud");
            dto.addSubQuery(subqueryestadosolicitud);

            dto.setOrderby("t.pk"); // En en string van todos los campos de orden ("t.pk,  t.nombre, t.cpais").

            if (getMfilelds().get("cargadeposito") != null) {
                Filter filtro = new Filter();
                filtro.setSql(getMfilelds().get("cargadeposito").toString());
                dto.addFiltro(filtro);
            }
            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(this.beanalias, dto); // permite adicionar mas de una tabla.
            request.setQueryTables(mtables);
            Response resp = this.callerhelper.executeQuery(request);
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                this.lrecord = new ArrayList<TarmSolicitudTramite>();
                MessageHelper.setMessageError(resp);
            } else {
                this.lrecord = (List<TarmSolicitudTramite>) resp.get(this.beanalias);
                super.postQuery(this.lrecord);
            }
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    /* (non-Javadoc)
	 * @see com.fp.frontend.controller.AbstractController#save()
     */
    @Override
    public void save() {
        try {
            Request request = this.callerhelper.getRequest();
            DtoSave dtosave = super.getDtoSave();
            if (!dtosave.pendingProcess()) {
                return;
            }
            HashMap<String, DtoSave> msave = new HashMap<String, DtoSave>();
            msave.put(this.beanalias, dtosave); // adicionar metadata de mantenimiento para cada tabla.
            request.setSaveTables(msave);
            Response resp = this.callerhelper.executeSave(request);
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) == 0) {
                this.postCommit(resp);
                MessageHelper.setMessageInfo(resp);
            } else {
                MessageHelper.setMessageError(resp);
            }
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    public void updateSolicitud(TarmSolicitudTramite bean) throws Exception {
        this.setRecord(bean);
        super.update();
    }

    /**
     * Metod para actualizar registro
     *
     * @param bean
     * @throws Exception
     */
    public void updateSimple(TarmSolicitudTramite bean) throws Exception {
        try {
            this.record = bean;
            super.update();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    /**
     * Metod para crear un nuevo registro y poner en la lista new
     *
     * @param bean
     * @throws Exception
     */
    public void update(TarmSolicitudTramite bean) throws Exception {
        super.create();
        record.getPk().setCsolicitud(bean.getPk().getCsolicitud());
        record.getPk().setCtramite(bean.getPk().getCtramite());
        record.setNumerotramite(bean.getNumerotramite());
        record.setValorapagar(bean.getValorapagar());
        record.setValorcustodios(bean.getValorcustodios());
        record.setValortramitearmas(bean.getValortramitearmas());
        record.setValormulta(bean.getValormulta());
        record.setEstadotramite(bean.getEstadotramite());
        record.setEstadotramitecodigo(bean.getEstadotramitecodigo());
        super.update();
    }

    public static TarmSolicitudTramite findByCSolicitud(String csolicitud) {
        try {
            SolicitudTramiteController cc = new SolicitudTramiteController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("pk.csolicitud", csolicitud);
            cc.querydatabase();
            if (cc.lrecord != null) {
                return cc.lrecord.get(0);
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }
    }

    public static TarmSolicitudTramite findByNumTramite(String numerotramite) {
        try {
            SolicitudTramiteController cc = new SolicitudTramiteController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("numerotramite", numerotramite);
            cc.querydatabase();
            if (cc.lrecord != null) {
                return cc.lrecord.get(0);
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }
    }

    public static TarmSolicitudTramite findByNumeroTramiteCarga(String numerotramite) {
        try {
            SolicitudTramiteController cc = new SolicitudTramiteController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("numerotramite", numerotramite);
            cc.getMfilelds().put("cargadeposito", "numerocomprobante is null ");//and csolicitud ="
            //+ "(select o.pk from TarmSolicitud o where o.estado='APB' and o.pk=(select p.numerotramite from TarmSolicitudTramite p where p.numerotramite='"+numerotramite+"'))");//
            cc.querydatabase();
            if (cc.lrecord != null && cc.lrecord.size() > 0) {
                if (codigoParametro("ACEPTADO").equals(cc.lrecord.get(0).getModifiedData().get("estadoSolicitud"))) {//"APB"
                    return cc.lrecord.get(0);
                }
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }
    }

    /**
     * M&eacute;todo para obtener los codigos de la tabla de parametros
     *
     * @return codigoAceptado
     * @throws Exception
     */
    private static String codigoParametro(String codigo) throws Exception {
        TgeneParameters f = ParametersController.find(codigo, "1");//APB  ESTADOSOLICITUD
        return f.getTextvalue();
    }

    /* (non-Javadoc)
	 * @see com.fp.frontend.controller.AbstractController#querydatabase()
     */
    @SuppressWarnings("unchecked")
    protected void querydatabaseNumeroComprobante() {
        try {
            Request request = this.callerhelper.getRequest();
            DtoQuery dto = super.getDtoQuery(true);
            Filter filtro = new Filter();
            filtro.setSql("(t.estadotramite<>'ANU' AND t.estadotramite<>'ANUDEP')");
            dto.addFiltro(filtro);
            SubQuery subqueryestadosolicitud = new SubQuery("TarmSolicitud", "estado", "estadoSolicitud", "i.pk=t.pk.csolicitud");
            dto.addSubQuery(subqueryestadosolicitud);

            dto.setOrderby("t.pk"); // En en string van todos los campos de orden ("t.pk,  t.nombre, t.cpais").
            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(this.beanalias, dto); // permite adicionar mas de una tabla.
            request.setQueryTables(mtables);
            Response resp = this.callerhelper.executeQuery(request);
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                this.lrecord = new ArrayList<TarmSolicitudTramite>();
                MessageHelper.setMessageError(resp);
            } else {
                this.lrecord = (List<TarmSolicitudTramite>) resp.get(this.beanalias);
                super.postQuery(this.lrecord);
            }
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    public static List<TarmSolicitudTramite> findByNumeroComprobante(String numComprobante) {
        try {
            SolicitudTramiteController cc = new SolicitudTramiteController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("numerocomprobante", numComprobante);
            cc.querydatabaseNumeroComprobante();
            return cc.lrecord;

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }
    }
    public static List<TarmSolicitudTramite> findByEstado(String estado) {
        try {
            SolicitudTramiteController cc = new SolicitudTramiteController();
            cc.init();
            cc.recperpage = 30;
            cc.addFilter("estadotramite", estado);
            cc.querydatabase();
            return cc.lrecord;

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }
    }
}
